<%@ Page Language="C#" %>

<%@ Register TagPrefix="telerik" Namespace="Telerik.Web.UI" Assembly="Telerik.Web.UI" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Highlight Entire Week on Date Hover</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:ScriptManager ID="ScriptManager1" runat="server">
        </asp:ScriptManager>
        <script type="text/javascript">
            function AddEvent(e)
            {
                var calendar = $get("<%=RadCalendar1.ClientID %>");
                if (typeof (calendar.addEventListener) != "undefined") //gecko browsers
                {
                    calendar.addEventListener("mouseover", HighlightWholeWeek, false);
                    calendar.addEventListener("mouseout", UnHighlight, false);
                }
                else if (calendar.attachEvent) //IE
                {
                    calendar.attachEvent("onmouseover", HighlightWholeWeek);
                    calendar.attachEvent("onmouseout", UnHighlight);
                }
            }

            function HighlightWholeWeek(args)
            {
                //find the clicked cell
                var target = FindTarget(args);
                if (target != null && (target.className == "radCalHover_Default" || target.className == "rcHover") && target.DayId) //if the highlighted cell is a date cell it has a DayId
                {
                    var row = target.parentNode;

                    //get all the rows to unhighlight first
                    var rows = row.parentNode.getElementsByTagName("tr");
                    UnhighlightRows(rows);
                    //highlight our row cells
                    var rowCells = row.getElementsByTagName("td");
                    for (var i = 0; i < rowCells.length; i++)
                    {
                        //don't highlight other month or selected days
                        
                        var oldSkins = target.className.indexOf("rc") != 0 ? true : false;//flag that indicates whether the version is earlier than Q1 2009.
                        if (target.className == "")
                        {
                            oldSkins = false;
                        }
                        if (oldSkins && rowCells[i].className != "otherMonth_Default" && rowCells[i].className != "radCalSelect_Default")
                        {
                            rowCells[i].className = "radCalHover_Default";
                        }
                        else if ((!oldSkins) && rowCells[i].className != "rcOtherMonth" && rowCells[i].className != "rcSelected")
                        {
                            rowCells[i].className = "rcHover";
                        }
                    }
                }
            }

            //unhighlight the lastly highlighted week on mouse out of the calendar
            function UnHighlight()
            {
                var calendar = document.getElementById("RadCalendar1_Top");
                //get the rows of the calendar table
                var rows = calendar.getElementsByTagName("tr");
                UnhighlightRows(rows);
            }

            function UnhighlightRows(rows)
            {
                for (var i = 0; i < rows.length; i++)
                {
                    //get the cells of the current row
                    var rowCells = rows[i].getElementsByTagName("td");
                    for (var j = 0; j < rowCells.length; j++)
                    {
                        //unhighlight the row cells
                        if (rowCells[j].className == "radCalHover_Default")
                        {
                            rowCells[j].className = "radCalDefault_Default";
                        }
                        else if (rowCells[j].className == "rcHover")
                        {
                            rowCells[j].className = "";
                        }
                    }
                }
            }

            function FindTarget(e)
            {
                var target;
                if (e && e.target) //other browsers
                {
                    target = e.target;
                }
                else if (window.event && window.event.srcElement) //IE
                {
                    target = window.event.srcElement;
                }

                if (!target)
                {
                    return null;
                }

                while (target != null && target.tagName != null)
                {
                    if (target.tagName.toLowerCase() == 'td')
                    {
                        break;
                    }
                    target = target.parentNode;
                }

                if (target == null || target.tagName == null || target.tagName.toLowerCase() != 'td')
                {
                    return null;
                }
                return target;
            }            
        </script>
        <telerik:RadCalendar ID="RadCalendar1" runat="server" ShowColumnHeaders="false" ShowRowHeaders="false">
            <ClientEvents OnLoad="AddEvent" />
        </telerik:RadCalendar>
    </div>
    </form>
</body>
</html>
